import { B as isArray_default, C as isArrayLike_default, H as _baseGetTag_default, R as identity_default, S as _isIterateeCall_default, T as _baseRest_default, V as isObjectLike_default, f as keysIn_default, k as eq_default } from "./isArrayLikeObject-LXbTYiBa.js";
import { t as isSymbol_default } from "./isSymbol-DCbjQG_U.js";
import { d as _arrayMap_default, n as _hasPath_default } from "./hasIn-DnfJcYpY.js";
import { i as toFinite_default } from "./_basePickBy-Sow3pJjS.js";
import { C as _baseFindIndex_default, b as keys_default, f as _baseIteratee_default, u as _baseEach_default } from "./_baseUniq-C87CckHL.js";
function toInteger(c) {
  var P = toFinite_default(c), F = P % 1;
  return P === P ? F ? P - F : P : 0;
}
var toInteger_default = toInteger, objectProto = Object.prototype, hasOwnProperty$1 = objectProto.hasOwnProperty, defaults_default = _baseRest_default(function(c, P) {
  c = Object(c);
  var F = -1, I = P.length, R = I > 2 ? P[2] : void 0;
  for (R && _isIterateeCall_default(P[0], P[1], R) && (I = 1); ++F < I; ) for (var z = P[F], H = keysIn_default(z), U = -1, W = H.length; ++U < W; ) {
    var G = H[U], K = c[G];
    (K === void 0 || eq_default(K, objectProto[G]) && !hasOwnProperty$1.call(c, G)) && (c[G] = z[G]);
  }
  return c;
});
function last(c) {
  var P = c == null ? 0 : c.length;
  return P ? c[P - 1] : void 0;
}
var last_default = last;
function createFind(c) {
  return function(F, I, L) {
    var R = Object(F);
    if (!isArrayLike_default(F)) {
      var z = _baseIteratee_default(I, 3);
      F = keys_default(F), I = function(c2) {
        return z(R[c2], c2, R);
      };
    }
    var B = c(F, I, L);
    return B > -1 ? R[z ? F[B] : B] : void 0;
  };
}
var _createFind_default = createFind, nativeMax = Math.max;
function findIndex(c, P, F) {
  var I = c == null ? 0 : c.length;
  if (!I) return -1;
  var L = F == null ? 0 : toInteger_default(F);
  return L < 0 && (L = nativeMax(I + L, 0)), _baseFindIndex_default(c, _baseIteratee_default(P, 3), L);
}
var find_default = _createFind_default(findIndex);
function baseMap(c, F) {
  var I = -1, L = isArrayLike_default(c) ? Array(c.length) : [];
  return _baseEach_default(c, function(c2, P, R) {
    L[++I] = F(c2, P, R);
  }), L;
}
var _baseMap_default = baseMap;
function map(P, F) {
  return (isArray_default(P) ? _arrayMap_default : _baseMap_default)(P, _baseIteratee_default(F, 3));
}
var map_default = map, hasOwnProperty = Object.prototype.hasOwnProperty;
function baseHas(c, P) {
  return c != null && hasOwnProperty.call(c, P);
}
var _baseHas_default = baseHas;
function has(c, P) {
  return c != null && _hasPath_default(c, P, _baseHas_default);
}
var has_default = has, stringTag = "[object String]";
function isString(P) {
  return typeof P == "string" || !isArray_default(P) && isObjectLike_default(P) && _baseGetTag_default(P) == stringTag;
}
var isString_default = isString;
function baseLt(c, P) {
  return c < P;
}
var _baseLt_default = baseLt;
function baseExtremum(c, P, F) {
  for (var I = -1, L = c.length; ++I < L; ) {
    var R = c[I], z = P(R);
    if (z != null && (B === void 0 ? z === z && !isSymbol_default(z) : F(z, B))) var B = z, V = R;
  }
  return V;
}
var _baseExtremum_default = baseExtremum;
function min(c) {
  return c && c.length ? _baseExtremum_default(c, identity_default, _baseLt_default) : void 0;
}
var min_default = min;
export {
  has_default as a,
  find_default as c,
  toInteger_default as d,
  isString_default as i,
  last_default as l,
  _baseExtremum_default as n,
  map_default as o,
  _baseLt_default as r,
  _baseMap_default as s,
  min_default as t,
  defaults_default as u
};
